#include "cons.h"

#define	KLADDR	((struct dldevice *)0177560)
/*#define	KLADDR	((struct dldevice *)017777560)*/

typedef unsigned char u_char;
typedef unsigned short u_short;

#ifdef __GNUC__
#define VOLATILE volatile
#define CONST const
#else
#define VOLATILE
#define CONST
#endif

void
putc(c)
char c;
{
	struct dldevice VOLATILE *kladdr = KLADDR;
	int s;
	unsigned int timo;

	/*
	 * Try waiting for the console tty to come ready,
	 * otherwise give up after a reasonable time.
	 */
	timo = 60000;
	while ((kladdr->dlxcsr & DLXCSR_TRDY) == 0)
		if (--timo == 0)
			break;
	if (c == 0)
		return;

	s = kladdr->dlxcsr;
	kladdr->dlxcsr = 0;
	kladdr->dlxbuf = c;
	if (c == '\n') {
		putc('\r');
	}
/*	putc(0); */
	kladdr->dlxcsr = s;
}

int
getc()
{
	struct dldevice VOLATILE *kladdr = KLADDR;
	char c;

	kladdr->dlrcsr = DL_RE;
	while ((kladdr->dlrcsr & DL_RDONE) == 0)
		;

	c = kladdr->dlrbuf & 0177;
	return c;
}

int
puts(s)
CONST char *s;
{
	while (*s)
		putc(*s++);
	return 0;
}

void
beep()
{
	putc(7);
}

char line[80];
int linelen;

void
parseline()
{
}

int
getline()
{
	int i, c;

	linelen = 0;
	while (1) {
		c = getc();
		switch (c) {
		case '\r':
			parseline();
			return;
		case 'U'-'@':
			for (i = 0; i < linelen; i++)
				puts("\b \b");
			linelen = 0;
			break;
		case '\b':
		case 0x7f:
			if (linelen == 0) {
				beep();
			} else {
				linelen--;
				puts("\b \b");
			}
			break;
		default:
			putc(c);
			if (linelen < 80)
				line[linelen++] = c;
			else
				beep();
		}
	}
}

main()
{
#if 0
	putc('\r');
	putc('\n');
	putc('H');
	putc('I');
#endif

	puts("\nshell\n");
	while (1) {
		puts("\nblah> ");
		getline();
	}
}
